
#ifdef GL_ES 
  precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform sampler2D u_alphaTexture;
uniform vec3 v_rotParam;

void main()
{ 
	vec4 color = vec4(0.0);

	vec2 tempUV;
	tempUV.x = v_texCoord.x;
	tempUV.y = v_texCoord.y;

	float fRadians = v_rotParam.x;
	float fCos = cos(fRadians);
	float fSin = sin(fRadians);

	vec2 uv;
	uv.x = tempUV.x * fCos + tempUV.y * fSin;
	uv.y = -tempUV.x * fSin + tempUV.y * fCos;

	//uv.x += v_rotParam.y;
	//uv.y = v_rotParam.z - uv.y;
	if(uv.x < 0.0)
	  uv.x = -uv.x;
	if(uv.y < 0.0)
	  uv.y = -uv.y;

	color   =  texture2D(u_texture, uv); 
	color.a =  texture2D(u_alphaTexture, uv).a;
	//color.a = color.a*0.001 + 1.0;
	color   =  v_fragmentColor * color;
	gl_FragColor =  color; 
}                                                            
