
#ifdef GL_ES                                
precision lowp float;                        
#endif                                        
                                            
varying vec4 v_fragmentColor;                
varying vec2 v_texCoord;                    
uniform sampler2D u_texture;
uniform sampler2D u_alphaTexture;
uniform       float u_alpha_value; 
uniform vec3 v_rotParam;
uniform vec4 v_addColor;               
                                            
void main()                                    
{
                                           
vec4 vStoneColor = texture2D(u_alphaTexture, v_texCoord);
vec3  colorStone = vStoneColor.rgb;
vec4 color      = texture2D(u_texture, v_texCoord);

// add color blend
color.rgb = v_addColor.rgb * v_addColor.a + color.rgb * (1.0 - v_addColor.a);

float luminColor = color.r + color.g + color.b;
float fv        = v_texCoord.y + luminColor * v_rotParam.y; 

//float fWeight   = step(v_rotParam.x,fv);
float fWeight = (fv - v_rotParam.x) * 1000.0;
fWeight = clamp(fWeight, 0.0, 1.0);

color.rgb = colorStone * fWeight + color.rgb*(1.0 - fWeight);
color.a = vStoneColor.a;
if(color.a < u_alpha_value)
   discard;
gl_FragColor =  color;               
}                                            

