// water effect
#ifdef GL_ES                                
precision lowp float;                        
#endif                                        
                                            
varying vec4 v_fragmentColor;                
varying vec2 v_texCoord;                    
uniform sampler2D u_texture;    
uniform sampler2D u_normalTexture;
uniform sampler2D u_depthTexture;   

uniform float normalMapUvScale[4];
uniform float normalMapScale[4];
uniform float normalMapInvAccWeights[4];
uniform vec2 speedScale[4];

uniform vec2  u_normalUVScale;
uniform float u_fwaveSpeed;
uniform float u_fwaveStrength;
uniform vec2  u_waveFlowDir;

uniform float u_fTime;

vec4 GetWaterNormalFromNormalMap(vec2 baseUV, float fTimer, vec2 fWaterFlowDirection,float fStrength, sampler2D normalMap){

  vec4 vNormal = vec4(0.0, 0.0, 0.0, 0.0);
  
  for (int i=0; i<4; i++)
  {
    vec2 tpos = baseUV * normalMapUvScale[i] + speedScale[i] * fTimer;
    tpos += fWaterFlowDirection;   
    vNormal += (texture2D(normalMap, tpos) - 0.5) * normalMapScale[i];
  }
  vNormal.xy *= fStrength;
  //vNormal.w *= normalMapInvAccWeights[WATER_NORMAL_TFETCHES-1];

  vNormal.xyz = normalize(vNormal.xyz);

  return vNormal;
} 

  
                                              
void main()                                    
{                                            
 
	vec4 colorNormal = vec4(0.0);
	vec2 normalUV=v_texCoord*u_normalUVScale;
	float fDepth = 1.0 - texture2D(u_depthTexture, v_texCoord).x;
	
	vec4 vNormal = vec4(0.0);
	
	if(fDepth > 0.001)
	vNormal = GetWaterNormalFromNormalMap(normalUV, u_fTime*u_fwaveSpeed, u_fTime*u_waveFlowDir, u_fwaveStrength, u_normalTexture);
	
	
	vNormal.xy *= fDepth;
	
	vec4 color = vec4(0.0);
    color =  texture2D(u_texture, v_texCoord + vNormal.xy); 
	//colorNormal = texture2D(u_normalTexture, v_texCoord); 
	color.rgb = v_fragmentColor.rgb * color.rgb;
    gl_FragColor = vec4(color.rgb,1.0) ;        
}                                            


